diff --git a/src/backend/commands/vacuum.c b/src/backend/commands/vacuum.c
new file mode 100644
index 9fbb0eb..2bd2697
*** a/src/backend/commands/vacuum.c
--- b/src/backend/commands/vacuum.c
***************
*** 55,64 ****
  /*
   * GUC parameters
   */
! int			vacuum_freeze_min_age;
! int			vacuum_freeze_table_age;
! int			vacuum_multixact_freeze_min_age;
! int			vacuum_multixact_freeze_table_age;
  
  
  /* A few variables that don't seem worth passing around as parameters */
--- 55,64 ----
  /*
   * GUC parameters
   */
! int64		vacuum_freeze_min_age;
! int64		vacuum_freeze_table_age;
! int64		vacuum_multixact_freeze_min_age;
! int64		vacuum_multixact_freeze_table_age;
  
  
  /* A few variables that don't seem worth passing around as parameters */
*************** get_rel_oids(Oid relid, const RangeVar *
*** 499,521 ****
   */
  void
  vacuum_set_xid_limits(Relation rel,
! 					  int freeze_min_age,
! 					  int freeze_table_age,
! 					  int multixact_freeze_min_age,
! 					  int multixact_freeze_table_age,
  					  TransactionId *oldestXmin,
  					  TransactionId *freezeLimit,
  					  TransactionId *xidFullScanLimit,
  					  MultiXactId *multiXactCutoff,
  					  MultiXactId *mxactFullScanLimit)
  {
! 	int			freezemin;
! 	int			mxid_freezemin;
! 	int			effective_multixact_freeze_max_age;
  	TransactionId limit;
  	TransactionId safeLimit;
  	MultiXactId mxactLimit;
  	MultiXactId safeMxactLimit;
  
  	/*
  	 * We can always ignore processes running lazy vacuum.  This is because we
--- 499,524 ----
   */
  void
  vacuum_set_xid_limits(Relation rel,
! 					  int64 freeze_min_age,
! 					  int64 freeze_table_age,
! 					  int64 multixact_freeze_min_age,
! 					  int64 multixact_freeze_table_age,
  					  TransactionId *oldestXmin,
  					  TransactionId *freezeLimit,
  					  TransactionId *xidFullScanLimit,
  					  MultiXactId *multiXactCutoff,
  					  MultiXactId *mxactFullScanLimit)
  {
! 	int64		freezemin;
! 	int64		mxid_freezemin;
! 	int64		effective_multixact_freeze_max_age;
  	TransactionId limit;
  	TransactionId safeLimit;
+ 	TransactionId nextXid;
+ 	MultiXactId oldestMxact;
  	MultiXactId mxactLimit;
  	MultiXactId safeMxactLimit;
+ 	MultiXactId nextMxactId;
  
  	/*
  	 * We can always ignore processes running lazy vacuum.  This is because we
*************** vacuum_set_xid_limits(Relation rel,
*** 546,553 ****
  	/*
  	 * Compute the cutoff XID, being careful not to generate a "permanent" XID
  	 */
! 	limit = *oldestXmin - freezemin;
! 	if (!TransactionIdIsNormal(limit))
  		limit = FirstNormalTransactionId;
  
  	/*
--- 549,558 ----
  	/*
  	 * Compute the cutoff XID, being careful not to generate a "permanent" XID
  	 */
! 	limit = *oldestXmin;
! 	if (limit > FirstNormalTransactionId + freezemin)
! 		limit -= freezemin;
! 	else
  		limit = FirstNormalTransactionId;
  
  	/*
*************** vacuum_set_xid_limits(Relation rel,
*** 555,562 ****
  	 * autovacuum_freeze_max_age / 2 XIDs old), complain and force a minimum
  	 * freeze age of zero.
  	 */
! 	safeLimit = ReadNewTransactionId() - autovacuum_freeze_max_age;
! 	if (!TransactionIdIsNormal(safeLimit))
  		safeLimit = FirstNormalTransactionId;
  
  	if (TransactionIdPrecedes(limit, safeLimit))
--- 560,569 ----
  	 * autovacuum_freeze_max_age / 2 XIDs old), complain and force a minimum
  	 * freeze age of zero.
  	 */
! 	nextXid = ReadNewTransactionId();
! 	if (nextXid > FirstNormalTransactionId + autovacuum_freeze_max_age)
! 		safeLimit = nextXid - autovacuum_freeze_max_age;
! 	else
  		safeLimit = FirstNormalTransactionId;
  
  	if (TransactionIdPrecedes(limit, safeLimit))
*************** vacuum_set_xid_limits(Relation rel,
*** 574,580 ****
  	 * normally autovacuum_multixact_freeze_max_age, but may be less if we are
  	 * short of multixact member space.
  	 */
! 	effective_multixact_freeze_max_age = MultiXactMemberFreezeThreshold();
  
  	/*
  	 * Determine the minimum multixact freeze age to use: as specified by
--- 581,587 ----
  	 * normally autovacuum_multixact_freeze_max_age, but may be less if we are
  	 * short of multixact member space.
  	 */
! 	effective_multixact_freeze_max_age = autovacuum_multixact_freeze_max_age;
  
  	/*
  	 * Determine the minimum multixact freeze age to use: as specified by
*************** vacuum_set_xid_limits(Relation rel,
*** 590,608 ****
  	Assert(mxid_freezemin >= 0);
  
  	/* compute the cutoff multi, being careful to generate a valid value */
! 	mxactLimit = GetOldestMultiXactId() - mxid_freezemin;
! 	if (mxactLimit < FirstMultiXactId)
  		mxactLimit = FirstMultiXactId;
  
! 	safeMxactLimit =
! 		ReadNextMultiXactId() - effective_multixact_freeze_max_age;
! 	if (safeMxactLimit < FirstMultiXactId)
  		safeMxactLimit = FirstMultiXactId;
  
  	if (MultiXactIdPrecedes(mxactLimit, safeMxactLimit))
  	{
  		ereport(WARNING,
! 				(errmsg("oldest multixact is far in the past"),
  				 errhint("Close open transactions with multixacts soon to avoid wraparound problems.")));
  		mxactLimit = safeMxactLimit;
  	}
--- 597,624 ----
  	Assert(mxid_freezemin >= 0);
  
  	/* compute the cutoff multi, being careful to generate a valid value */
! 	oldestMxact = GetOldestMultiXactId();
! 	if (oldestMxact > FirstMultiXactId + mxid_freezemin)
! 		mxactLimit = oldestMxact - mxid_freezemin;
! 	else
  		mxactLimit = FirstMultiXactId;
  
! 	nextMxactId = ReadNextMultiXactId();
! 	if (nextMxactId > FirstMultiXactId + effective_multixact_freeze_max_age)
! 		safeMxactLimit = nextMxactId - effective_multixact_freeze_max_age;
! 	else
  		safeMxactLimit = FirstMultiXactId;
  
  	if (MultiXactIdPrecedes(mxactLimit, safeMxactLimit))
  	{
  		ereport(WARNING,
! 				(errmsg("oldest multixact is far in the past: "
! 					INT64_FORMAT " " INT64_FORMAT " "
! 					INT64_FORMAT " " INT64_FORMAT " " INT64_FORMAT " "
! 					INT64_FORMAT " " INT64_FORMAT " " INT64_FORMAT " ",
! 					multixact_freeze_min_age, vacuum_multixact_freeze_min_age,
! 					mxactLimit, mxid_freezemin, oldestMxact,
! 					safeMxactLimit, effective_multixact_freeze_max_age, nextMxactId),
  				 errhint("Close open transactions with multixacts soon to avoid wraparound problems.")));
  		mxactLimit = safeMxactLimit;
  	}
*************** vacuum_set_xid_limits(Relation rel,
*** 632,639 ****
  		 * Compute XID limit causing a full-table vacuum, being careful not to
  		 * generate a "permanent" XID.
  		 */
! 		limit = ReadNewTransactionId() - freezetable;
! 		if (!TransactionIdIsNormal(limit))
  			limit = FirstNormalTransactionId;
  
  		*xidFullScanLimit = limit;
--- 648,657 ----
  		 * Compute XID limit causing a full-table vacuum, being careful not to
  		 * generate a "permanent" XID.
  		 */
! 		limit = ReadNewTransactionId();
! 		if (limit > FirstNormalTransactionId + freezetable)
! 			limit -= freezetable;
! 		else
  			limit = FirstNormalTransactionId;
  
  		*xidFullScanLimit = limit;
*************** vacuum_set_xid_limits(Relation rel,
*** 657,664 ****
  		 * Compute MultiXact limit causing a full-table vacuum, being careful
  		 * to generate a valid MultiXact value.
  		 */
! 		mxactLimit = ReadNextMultiXactId() - freezetable;
! 		if (mxactLimit < FirstMultiXactId)
  			mxactLimit = FirstMultiXactId;
  
  		*mxactFullScanLimit = mxactLimit;
--- 675,684 ----
  		 * Compute MultiXact limit causing a full-table vacuum, being careful
  		 * to generate a valid MultiXact value.
  		 */
! 		mxactLimit = ReadNextMultiXactId();
! 		if (mxactLimit > FirstMultiXactId + freezetable)
! 			mxactLimit -= freezetable;
! 		else
  			mxactLimit = FirstMultiXactId;
  
  		*mxactFullScanLimit = mxactLimit;
*************** vac_truncate_clog(TransactionId frozenXI
*** 1192,1204 ****
  	AdvanceOldestCommitTsXid(frozenXID);
  
  	/*
- 	 * Truncate CLOG, multixact and CommitTs to the oldest computed value.
- 	 */
- 	TruncateCLOG(frozenXID, oldestxid_datoid);
- 	TruncateCommitTs(frozenXID);
- 	TruncateMultiXact(minMulti, minmulti_datoid);
- 
- 	/*
  	 * Update the wrap limit for GetNewTransactionId and creation of new
  	 * MultiXactIds.  Note: these functions will also signal the postmaster
  	 * for an(other) autovac cycle if needed.   XXX should we avoid possibly
--- 1212,1217 ----
*************** vac_truncate_clog(TransactionId frozenXI
*** 1206,1211 ****
--- 1219,1231 ----
  	 */
  	SetTransactionIdLimit(frozenXID, oldestxid_datoid);
  	SetMultiXactIdLimit(minMulti, minmulti_datoid, false);
+ 
+ 	/*
+ 	 * Truncate CLOG, multixact and CommitTs to the oldest computed value.
+ 	 */
+ 	TruncateCLOG(frozenXID, oldestxid_datoid);
+ 	TruncateCommitTs(frozenXID);
+ 	TruncateMultiXact(minMulti, minmulti_datoid);
  }
  
  
diff --git a/src/backend/commands/vacuumlazy.c b/src/backend/commands/vacuumlazy.c
new file mode 100644
index 2b66bfd..923f61a
*** a/src/backend/commands/vacuumlazy.c
--- b/src/backend/commands/vacuumlazy.c
*************** lazy_vacuum_rel(Relation onerel, int opt
*** 385,391 ****
  							 vacrelstats->pinskipped_pages,
  							 vacrelstats->frozenskipped_pages);
  			appendStringInfo(&buf,
! 							 _("tuples: %.0f removed, %.0f remain, %.0f are dead but not yet removable, oldest xmin: %u\n"),
  							 vacrelstats->tuples_deleted,
  							 vacrelstats->new_rel_tuples,
  							 vacrelstats->new_dead_tuples,
--- 385,391 ----
  							 vacrelstats->pinskipped_pages,
  							 vacrelstats->frozenskipped_pages);
  			appendStringInfo(&buf,
! 							 _("tuples: %.0f removed, %.0f remain, %.0f are dead but not yet removable, oldest xmin: " XID_FMT "\n"),
  							 vacrelstats->tuples_deleted,
  							 vacrelstats->new_rel_tuples,
  							 vacrelstats->new_dead_tuples,
*************** lazy_scan_heap(Relation onerel, int opti
*** 860,865 ****
--- 860,866 ----
  				(errmsg("relation \"%s\" page %u is uninitialized --- fixing",
  						relname, blkno)));
  				PageInit(page, BufferGetPageSize(buf), sizeof(HeapPageSpecialData));
+ 				HeapPageGetSpecial(page)->pd_xid_base = RecentXmin - FirstNormalTransactionId;
  				HeapPageGetSpecial(page)->pd_magic = HEAP_PAGE_MAGIC;
  				empty_pages++;
  			}
*************** lazy_scan_heap(Relation onerel, int opti
*** 916,922 ****
  		 * We count tuples removed by the pruning step as removed by VACUUM.
  		 */
  		tups_vacuumed += heap_page_prune(onerel, buf, OldestXmin, false,
! 										 &vacrelstats->latestRemovedXid);
  
  		/*
  		 * Now scan the page to collect vacuumable items and check for tuples
--- 917,923 ----
  		 * We count tuples removed by the pruning step as removed by VACUUM.
  		 */
  		tups_vacuumed += heap_page_prune(onerel, buf, OldestXmin, false,
! 										 &vacrelstats->latestRemovedXid, true);
  
  		/*
  		 * Now scan the page to collect vacuumable items and check for tuples
*************** lazy_scan_heap(Relation onerel, int opti
*** 975,980 ****
--- 976,982 ----
  			tuple.t_data = (HeapTupleHeader) PageGetItem(page, itemid);
  			tuple.t_len = ItemIdGetLength(itemid);
  			tuple.t_tableOid = RelationGetRelid(onerel);
+ 			HeapTupleCopyBaseFromPage(&tuple, page);
  
  			tupgone = false;
  
*************** lazy_scan_heap(Relation onerel, int opti
*** 1034,1040 ****
  						 * The inserter definitely committed. But is it old
  						 * enough that everyone sees it as committed?
  						 */
! 						xmin = HeapTupleHeaderGetXmin(tuple.t_data);
  						if (!TransactionIdPrecedes(xmin, OldestXmin))
  						{
  							all_visible = false;
--- 1036,1042 ----
  						 * The inserter definitely committed. But is it old
  						 * enough that everyone sees it as committed?
  						 */
! 						xmin = HeapTupleGetXmin(&tuple);
  						if (!TransactionIdPrecedes(xmin, OldestXmin))
  						{
  							all_visible = false;
*************** lazy_scan_heap(Relation onerel, int opti
*** 1071,1077 ****
  			if (tupgone)
  			{
  				lazy_record_dead_tuple(vacrelstats, &(tuple.t_self));
! 				HeapTupleHeaderAdvanceLatestRemovedXid(tuple.t_data,
  											 &vacrelstats->latestRemovedXid);
  				tups_vacuumed += 1;
  				has_dead_tuples = true;
--- 1073,1079 ----
  			if (tupgone)
  			{
  				lazy_record_dead_tuple(vacrelstats, &(tuple.t_self));
! 				HeapTupleHeaderAdvanceLatestRemovedXid(&tuple,
  											 &vacrelstats->latestRemovedXid);
  				tups_vacuumed += 1;
  				has_dead_tuples = true;
*************** lazy_scan_heap(Relation onerel, int opti
*** 1087,1093 ****
  				 * Each non-removable tuple must be checked to see if it needs
  				 * freezing.  Note we already have exclusive buffer lock.
  				 */
! 				if (heap_prepare_freeze_tuple(tuple.t_data, FreezeLimit,
  										   MultiXactCutoff, &frozen[nfrozen],
  											  &tuple_totally_frozen))
  					frozen[nfrozen++].offset = offnum;
--- 1089,1095 ----
  				 * Each non-removable tuple must be checked to see if it needs
  				 * freezing.  Note we already have exclusive buffer lock.
  				 */
! 				if (heap_prepare_freeze_tuple(&tuple, FreezeLimit,
  										   MultiXactCutoff, &frozen[nfrozen],
  											  &tuple_totally_frozen))
  					frozen[nfrozen++].offset = offnum;
*************** lazy_scan_heap(Relation onerel, int opti
*** 1117,1123 ****
  				itemid = PageGetItemId(page, frozen[i].offset);
  				htup = (HeapTupleHeader) PageGetItem(page, itemid);
  
! 				heap_execute_freeze_tuple(htup, &frozen[i]);
  			}
  
  			/* Now WAL-log freezing if necessary */
--- 1119,1125 ----
  				itemid = PageGetItemId(page, frozen[i].offset);
  				htup = (HeapTupleHeader) PageGetItem(page, itemid);
  
! 				heap_execute_freeze_tuple_page(page, htup, &frozen[i]);
  			}
  
  			/* Now WAL-log freezing if necessary */
*************** lazy_scan_heap(Relation onerel, int opti
*** 1338,1344 ****
  	 */
  	initStringInfo(&buf);
  	appendStringInfo(&buf,
! 		_("%.0f dead row versions cannot be removed yet, oldest xmin: %u\n"),
  					 nkeep, OldestXmin);
  	appendStringInfo(&buf, _("There were %.0f unused item pointers.\n"),
  					 nunused);
--- 1340,1346 ----
  	 */
  	initStringInfo(&buf);
  	appendStringInfo(&buf,
! 		_("%.0f dead row versions cannot be removed yet, oldest xmin: " XID_FMT "\n"),
  					 nkeep, OldestXmin);
  	appendStringInfo(&buf, _("There were %.0f unused item pointers.\n"),
  					 nunused);
*************** lazy_check_needs_freeze(Buffer buf, bool
*** 1564,1569 ****
--- 1566,1572 ----
  		 offnum = OffsetNumberNext(offnum))
  	{
  		ItemId		itemid;
+ 		HeapTupleData htup;
  
  		itemid = PageGetItemId(page, offnum);
  
*************** lazy_check_needs_freeze(Buffer buf, bool
*** 1577,1583 ****
  
  		tupleheader = (HeapTupleHeader) PageGetItem(page, itemid);
  
! 		if (heap_tuple_needs_freeze(tupleheader, FreezeLimit,
  									MultiXactCutoff, buf))
  			return true;
  	}							/* scan along page */
--- 1580,1589 ----
  
  		tupleheader = (HeapTupleHeader) PageGetItem(page, itemid);
  
! 		htup.t_data = tupleheader;
! 		HeapTupleCopyBaseFromPage(&htup, page);
! 
! 		if (heap_tuple_needs_freeze(&htup, FreezeLimit,
  									MultiXactCutoff, buf))
  			return true;
  	}							/* scan along page */
*************** heap_page_is_all_visible(Relation rel, B
*** 2142,2147 ****
--- 2148,2154 ----
  		tuple.t_data = (HeapTupleHeader) PageGetItem(page, itemid);
  		tuple.t_len = ItemIdGetLength(itemid);
  		tuple.t_tableOid = RelationGetRelid(rel);
+ 		HeapTupleCopyBaseFromPage(&tuple, page);
  
  		switch (HeapTupleSatisfiesVacuum(&tuple, OldestXmin, buf))
  		{
*************** heap_page_is_all_visible(Relation rel, B
*** 2161,2167 ****
  					 * The inserter definitely committed. But is it old enough
  					 * that everyone sees it as committed?
  					 */
! 					xmin = HeapTupleHeaderGetXmin(tuple.t_data);
  					if (!TransactionIdPrecedes(xmin, OldestXmin))
  					{
  						all_visible = false;
--- 2168,2174 ----
  					 * The inserter definitely committed. But is it old enough
  					 * that everyone sees it as committed?
  					 */
! 					xmin = HeapTupleGetXmin(&tuple);
  					if (!TransactionIdPrecedes(xmin, OldestXmin))
  					{
  						all_visible = false;
diff --git a/src/backend/executor/execExprInterp.c b/src/backend/executor/execExprInterp.c
new file mode 100644
index fed0052..6596a72
*** a/src/backend/executor/execExprInterp.c
--- b/src/backend/executor/execExprInterp.c
*************** ExecEvalFieldStoreDeForm(ExprState *stat
*** 2551,2556 ****
--- 2551,2557 ----
  		tmptup.t_len = HeapTupleHeaderGetDatumLength(tuphdr);
  		ItemPointerSetInvalid(&(tmptup.t_self));
  		tmptup.t_tableOid = InvalidOid;
+ 		HeapTupleSetZeroBase(&tmptup);
  		tmptup.t_data = tuphdr;
  
  		heap_deform_tuple(&tmptup, tupDesc,
diff --git a/src/backend/executor/execMain.c b/src/backend/executor/execMain.c
new file mode 100644
index 7f460bd..5036610
*** a/src/backend/executor/execMain.c
--- b/src/backend/executor/execMain.c
*************** EvalPlanQualFetch(EState *estate, Relati
*** 2543,2549 ****
  			 * atomic, and Xmin never changes in an existing tuple, except to
  			 * invalid or frozen, and neither of those can match priorXmax.)
  			 */
! 			if (!TransactionIdEquals(HeapTupleHeaderGetXmin(tuple.t_data),
  									 priorXmax))
  			{
  				ReleaseBuffer(buffer);
--- 2543,2549 ----
  			 * atomic, and Xmin never changes in an existing tuple, except to
  			 * invalid or frozen, and neither of those can match priorXmax.)
  			 */
! 			if (!TransactionIdEquals(HeapTupleGetXmin(&tuple),
  									 priorXmax))
  			{
  				ReleaseBuffer(buffer);
*************** EvalPlanQualFetch(EState *estate, Relati
*** 2691,2697 ****
  		/*
  		 * As above, if xmin isn't what we're expecting, do nothing.
  		 */
! 		if (!TransactionIdEquals(HeapTupleHeaderGetXmin(tuple.t_data),
  								 priorXmax))
  		{
  			ReleaseBuffer(buffer);
--- 2691,2697 ----
  		/*
  		 * As above, if xmin isn't what we're expecting, do nothing.
  		 */
! 		if (!TransactionIdEquals(HeapTupleGetXmin(&tuple),
  								 priorXmax))
  		{
  			ReleaseBuffer(buffer);
*************** EvalPlanQualFetch(EState *estate, Relati
*** 2720,2726 ****
  		/* updated, so look at the updated row */
  		tuple.t_self = tuple.t_data->t_ctid;
  		/* updated row should have xmin matching this xmax */
! 		priorXmax = HeapTupleHeaderGetUpdateXid(tuple.t_data);
  		ReleaseBuffer(buffer);
  		/* loop back to fetch next in chain */
  	}
--- 2720,2726 ----
  		/* updated, so look at the updated row */
  		tuple.t_self = tuple.t_data->t_ctid;
  		/* updated row should have xmin matching this xmax */
! 		priorXmax = HeapTupleGetUpdateXidAny(&tuple);
  		ReleaseBuffer(buffer);
  		/* loop back to fetch next in chain */
  	}
*************** EvalPlanQualFetchRowMarks(EPQState *epqs
*** 2930,2935 ****
--- 2930,2936 ----
  			tuple.t_tableOid = erm->relid;
  			/* also copy t_ctid in case there's valid data there */
  			tuple.t_self = td->t_ctid;
+ 			HeapTupleSetZeroBase(&tuple);
  
  			/* copy and store tuple */
  			EvalPlanQualSetTuple(epqstate, erm->rti,
diff --git a/src/backend/executor/execUtils.c b/src/backend/executor/execUtils.c
new file mode 100644
index cb2596c..89d1de0
*** a/src/backend/executor/execUtils.c
--- b/src/backend/executor/execUtils.c
*************** GetAttributeByNum(HeapTupleHeader tuple,
*** 978,983 ****
--- 978,985 ----
  	tmptup.t_len = HeapTupleHeaderGetDatumLength(tuple);
  	ItemPointerSetInvalid(&(tmptup.t_self));
  	tmptup.t_tableOid = InvalidOid;
+ 	HeapTupleSetZeroBase(&tmptup);
+ 	HeapTupleSetZeroBase(&tmptup);
  	tmptup.t_data = tuple;
  
  	result = heap_getattr(&tmptup,
diff --git a/src/backend/executor/nodeBitmapHeapscan.c b/src/backend/executor/nodeBitmapHeapscan.c
new file mode 100644
index 77f65db..f3dac40
*** a/src/backend/executor/nodeBitmapHeapscan.c
--- b/src/backend/executor/nodeBitmapHeapscan.c
*************** BitmapHeapNext(BitmapHeapScanState *node
*** 297,302 ****
--- 297,303 ----
  		scan->rs_ctup.t_data = (HeapTupleHeader) PageGetItem((Page) dp, lp);
  		scan->rs_ctup.t_len = ItemIdGetLength(lp);
  		scan->rs_ctup.t_tableOid = scan->rs_rd->rd_id;
+ 		HeapTupleCopyBaseFromPage(&scan->rs_ctup, dp);
  		ItemPointerSet(&scan->rs_ctup.t_self, tbmres->blockno, targoffset);
  
  		pgstat_count_heap_fetch(scan->rs_rd);
*************** bitgetpage(HeapScanDesc scan, TBMIterate
*** 424,429 ****
--- 425,431 ----
  			loctup.t_data = (HeapTupleHeader) PageGetItem((Page) dp, lp);
  			loctup.t_len = ItemIdGetLength(lp);
  			loctup.t_tableOid = scan->rs_rd->rd_id;
+ 			HeapTupleCopyBaseFromPage(&loctup, dp);
  			ItemPointerSet(&loctup.t_self, page, offnum);
  			valid = HeapTupleSatisfiesVisibility(&loctup, snapshot, buffer);
  			if (valid)
diff --git a/src/backend/executor/nodeModifyTable.c b/src/backend/executor/nodeModifyTable.c
new file mode 100644
index ff5ad98..78563ee
*** a/src/backend/executor/nodeModifyTable.c
--- b/src/backend/executor/nodeModifyTable.c
*************** ExecCheckHeapTupleVisible(EState *estate
*** 208,214 ****
  		 * visible to our snapshot.  (This would happen, for example, if
  		 * conflicting keys are proposed for insertion in a single command.)
  		 */
! 		if (!TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmin(tuple->t_data)))
  			ereport(ERROR,
  					(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
  			 errmsg("could not serialize access due to concurrent update")));
--- 208,214 ----
  		 * visible to our snapshot.  (This would happen, for example, if
  		 * conflicting keys are proposed for insertion in a single command.)
  		 */
! 		if (!TransactionIdIsCurrentTransactionId(HeapTupleGetXmin(tuple)))
  			ereport(ERROR,
  					(errcode(ERRCODE_T_R_SERIALIZATION_FAILURE),
  			 errmsg("could not serialize access due to concurrent update")));
*************** ExecOnConflictUpdate(ModifyTableState *m
*** 1212,1218 ****
  			 * that for SQL MERGE, an exception must be raised in the event of
  			 * an attempt to update the same row twice.
  			 */
! 			if (TransactionIdIsCurrentTransactionId(HeapTupleHeaderGetXmin(tuple.t_data)))
  				ereport(ERROR,
  						(errcode(ERRCODE_CARDINALITY_VIOLATION),
  						 errmsg("ON CONFLICT DO UPDATE command cannot affect row a second time"),
--- 1212,1218 ----
  			 * that for SQL MERGE, an exception must be raised in the event of
  			 * an attempt to update the same row twice.
  			 */
! 			if (TransactionIdIsCurrentTransactionId(HeapTupleGetXmin(&tuple)))
  				ereport(ERROR,
  						(errcode(ERRCODE_CARDINALITY_VIOLATION),
  						 errmsg("ON CONFLICT DO UPDATE command cannot affect row a second time"),
*************** ExecModifyTable(ModifyTableState *node)
*** 1594,1599 ****
--- 1594,1600 ----
  						HeapTupleHeaderGetDatumLength(oldtupdata.t_data);
  					ItemPointerSetInvalid(&(oldtupdata.t_self));
  					/* Historically, view triggers see invalid t_tableOid. */
+ 					HeapTupleSetZeroBase(&oldtupdata);
  					oldtupdata.t_tableOid =
  						(relkind == RELKIND_VIEW) ? InvalidOid :
  						RelationGetRelid(resultRelInfo->ri_RelationDesc);
diff --git a/src/backend/executor/nodeSamplescan.c b/src/backend/executor/nodeSamplescan.c
new file mode 100644
index 0247bd2..e880ef6
*** a/src/backend/executor/nodeSamplescan.c
--- b/src/backend/executor/nodeSamplescan.c
*************** tablesample_getnext(SampleScanState *sca
*** 453,458 ****
--- 453,459 ----
  
  			tuple->t_data = (HeapTupleHeader) PageGetItem(page, itemid);
  			tuple->t_len = ItemIdGetLength(itemid);
+ 			HeapTupleCopyBaseFromPage(tuple, page);
  			ItemPointerSet(&(tuple->t_self), blockno, tupoffset);
  
  			if (all_visible)
diff --git a/src/backend/executor/spi.c b/src/backend/executor/spi.c
new file mode 100644
index 97c3925..d6a2ece
*** a/src/backend/executor/spi.c
--- b/src/backend/executor/spi.c
*************** SPI_modifytuple(Relation rel, HeapTuple 
*** 740,745 ****
--- 740,746 ----
  		mtuple->t_data->t_ctid = tuple->t_data->t_ctid;
  		mtuple->t_self = tuple->t_self;
  		mtuple->t_tableOid = tuple->t_tableOid;
+ 		HeapTupleCopyBase(mtuple, tuple);
  		if (rel->rd_att->tdhasoid)
  			HeapTupleSetOid(mtuple, HeapTupleGetOid(tuple));
  	}
diff --git a/src/backend/executor/tqueue.c b/src/backend/executor/tqueue.c
new file mode 100644
index 8d7e711..a39a6af
*** a/src/backend/executor/tqueue.c
--- b/src/backend/executor/tqueue.c
*************** TQExamineRecord(TQueueDestReceiver *tque
*** 436,441 ****
--- 436,442 ----
  		ItemPointerSetInvalid(&(tdata.t_self));
  		tdata.t_tableOid = InvalidOid;
  		tdata.t_data = tup;
+ 		HeapTupleSetZeroBase(&tdata);
  		heap_deform_tuple(&tdata, tupledesc, values, isnull);
  
  		/* Recursively check each interesting non-NULL attribute. */
*************** TupleQueueHandleDataMessage(TupleQueueRe
*** 745,750 ****
--- 746,752 ----
  	htup.t_tableOid = InvalidOid;
  	htup.t_len = nbytes;
  	htup.t_data = data;
+ 	HeapTupleSetZeroBase(&htup);
  
  	/*
  	 * Either just copy the data into a regular palloc'd tuple, or remap it,
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
new file mode 100644
index 939045d..7ff52ec
*** a/src/backend/optimizer/util/plancat.c
--- b/src/backend/optimizer/util/plancat.c
*************** get_relation_info(PlannerInfo *root, Oid
*** 208,214 ****
  			 * src/backend/access/heap/README.HOT for discussion.
  			 */
  			if (index->indcheckxmin &&
! 				!TransactionIdPrecedes(HeapTupleHeaderGetXmin(indexRelation->rd_indextuple->t_data),
  									   TransactionXmin))
  			{
  				root->glob->transientPlan = true;
--- 208,214 ----
  			 * src/backend/access/heap/README.HOT for discussion.
  			 */
  			if (index->indcheckxmin &&
! 				!TransactionIdPrecedes(HeapTupleGetXmin(indexRelation->rd_indextuple),
  									   TransactionXmin))
  			{
  				root->glob->transientPlan = true;
